local idTweaksUtils, idTweaksOptions, Option, map, RangeOption
do
  local _obj_0 = _G
  idTweaksUtils, idTweaksOptions = _obj_0.idTweaksUtils, _obj_0.idTweaksOptions
end
Option = idTweaksOptions.Option
map = idTweaksUtils.table.map
do
  local _class_0
  local _parent_0 = Option
  local _base_0 = {
    get_aceconfig_options = function(self)
      local output = {
        order = self.order,
        type = self.type,
        name = self.name,
        desc = self.description,
        disabled = self:create_disabled(),
        hidden = self:create_hidden(),
        get = self:create_get(),
        set = self:create_set(),
        min = self:create_min(),
        max = self:create_max(),
        step = self:create_step()
      }
      if self.num_options > 0 then
        output.args = map.map((function(v)
          return v:get_aceconfig_options()
        end), self.options)
      end
      return output
    end,
    create_min = function(self)
      return function()
        return 0
      end
    end,
    create_max = function(self)
      return function()
        return 10
      end
    end,
    create_step = function(self)
      return function()
        return 1
      end
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  _class_0 = setmetatable({
    __init = function(self, module_instance, key, name, description, values, options, default)
      if values == nil then
        values = { }
      end
      if options == nil then
        options = { }
      end
      if default == nil then
        default = 0
      end
      _class_0.__parent.__init(self, module_instance, key, name, description, values, options, default)
      self.type = "range"
    end,
    __base = _base_0,
    __name = "RangeOption",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        local parent = rawget(cls, "__parent")
        if parent then
          return parent[name]
        end
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  RangeOption = _class_0
end
idTweaksOptions.RangeOption = RangeOption
